<?php
declare(strict_types=1);

namespace FiloBlu\RuleDayFromBirthday\Model\Config\Source;

use Magento\Framework\App\ResourceConnection;
use Magento\Framework\Option\ArrayInterface;

/**
 * @class CustomerSources
 * @package FiloBlu\RuleDayFromBirthday\Model\Config
 */
class CustomerSources implements ArrayInterface
{

    /**
     * @var ResourceConnection
     */
    private $resourceConnection;

    /**
     * @param ResourceConnection $resourceConnection
     */
    public function __construct(
        ResourceConnection $resourceConnection
    ) {
        $this->resourceConnection = $resourceConnection;
    }

    /**
     * @return array
     */
    public function toOptionArray()
    {
        $options = [];

        $connection = $this->resourceConnection->getConnection();
        $table = $connection->getTableName('customer_entity');

        $select = $connection
            ->select()
            ->from($table, ['created_in'])
            ->distinct();

        $result = $connection->fetchCol($select);
        foreach ($result as $row) {
            $options[] = [
                'value' => $row,
                'label' => $row,
            ];
        }

        return $options;
    }
}
